Housekeeping

Autor:            Christian Wally
Erstell am:       21.8.2024
Zuletzt geändert: 21.8.2024

Um einen dauerhaft problemlosen Betrieb von i-doit zu gewährleisten, bietet es sich an einige housekeeping tasks zu automatisieren:

  • Archivieren alter Logbuch-Einträge
  • Bereinigen des Cache für das Berechtigungssystems
  • Entfernen „unfertiger“ Objekte (das sind Objekte die erstellt aber nicht gespeichert werden)
  • Erneuern des Suchindexes
  • Versenden anstehender Nachrichten
  • Bereinigen des System-Caches
  • Löschen von Updates
  • Verlängern von Verträgen (extend-contract)
  • Aktualisieren veralteter Verträge (contracts-outdated); der CMDB Status wird auf „Außer Betrieb“ gesetzt und der Objekt-Status auf „Archiviert“. Der Vertragsstatus wird auf „beendet“ gesetzt.

Config anlegen

Zunächst erstellen wir eine Konfigurationsdatei mit Zugangsdaten zu i-doit, Pfadangaben und ähnlichem:

CONSOLE_BIN="/usr/local/bin/idoit"
INSTANCE_PATH="/var/html/www/i-doit"
APACHE_USER="www-data"
IDOIT_USERNAME="username"
IDOIT_PASSWORD="password"
TENANT_ID="1"
ARGS="$*"

Diese Konfigurationsdatei kann beispielsweise unter /etc/i-doit/idoitjpbs.conf abgelegt werden.

Wrapper für das console Kommando

Dann erstellen wir ein Wrapper-Script für das i-doit console Kommando. Auf dieses Script verweist auch die erste Zeile unserer zuvor erstellten Config. In unswerem Fall muss es also idoit heißen, unter /usr/local/bin/ abgelegt und zum Beispiel mit chmod +x /usr/local/bin/idoit ausführbar gemacht werden.

#!/bin/bash

##
## i-doit console
##

##
## Copyright (C) 2017-18 synetics GmbH, <https://i-doit.com/>
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU Affero General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU Affero General Public License for more details.
##
## You should have received a copy of the GNU Affero General Public License
## along with this program. If not, see <http://www.gnu.org/licenses/>.
##

set -euo pipefail

##
## Configuration
##

. /etc/i-doit/idoitjobs.conf
##--------------------------------------------------------------------------------------------------

function execute {
    local prefix=""
    local console="php console.php $ARGS"

    test "$(whoami)" != "$APACHE_USER" && prefix="sudo -u $APACHE_USER "

    eval "${prefix}${console}" || abort "i-doit console exited with non-zero status"
}

function setup {
    cd "$INSTANCE_PATH" || abort "No i-doit instance found under '${INSTANCE_PATH}'"
}

function finish {
    exit 0
}

function abort {
    echo -e "$1"  1>&2
    echo "Operation failed. Please check what is wrong and try again." 1>&2
    exit 1
}

function log {
    echo -e "$1"
}

##--------------------------------------------------------------------------------------------------

if [[ "${BASH_SOURCE[0]}" = "$0" ]]; then
    setup && execute && finish
fi

Die Jobs

Schließlich erstellen wir ein Script, das die eigentlichen Jobs ausführt und via Cron aufgerufen werden kann. Ich nenne es idoitjobs.sh und lege es ebenfalls unter /usr/local/bin/ und mache es ausführbar: chmod +x /usr/local/bin/idoitjobs.sh.

Das Script sieht so aus:

#!/bin/bash

##
## i-doit jobs
##

##
## Copyright (C) 2017-18 synetics GmbH, <https://i-doit.com/>
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU Affero General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU Affero General Public License for more details.
##
## You should have received a copy of the GNU Affero General Public License
## along with this program. If not, see <http://www.gnu.org/licenses/>.
##

set -euo pipefail
IFS=$'\n\t'

##
## Configuration
##

. /etc/i-doit/idoitjobs.conf
##--------------------------------------------------------------------------------------------------

function execute {
    local prefix=""
    local suffix="--user $IDOIT_USERNAME --password $IDOIT_PASSWORD --tenantId $TENANT_ID"

    test "$(whoami)" != "$APACHE_USER" && prefix="sudo -u $APACHE_USER "

    log "Archive i-doit logbook"
    eval "${prefix}${CONSOLE_BIN} logbook-archive $suffix" || \
        abort "Command 'logbook-archive' failed"
    log ""

    log "Cleanup i-doit rights"
    eval "${prefix}${CONSOLE_BIN} auth-cleanup $suffix" || \
        abort "Command 'auth-cleanup' failed"
    log ""

    log "Purge unfinished objects"
    eval "${prefix}${CONSOLE_BIN} system-objectcleanup --objectStatus 1 $suffix" || \
        abort "Command 'system-objectcleanup' failed"
    log ""

    log "Re-create search index"
    eval "${prefix}${CONSOLE_BIN} search-index $suffix" || \
        abort "Command 'search-index' failed"

    log "Send notifications"
    eval "${prefix}${CONSOLE_BIN} notifications-send $suffix" || \
        abort "Command 'notifications-send' failed"

    log "Clear caches"
    eval "${prefix}rm -rf ${INSTANCE_PATH}/temp/*" || \
        abort "Unable to clear caches"

    log "Clear updates"
    eval "${prefix}rm -rf ${INSTANCE_PATH}/updates/versions/*" || \
        abort "Unable to clear updates"

    log "Extend contracts"
    eval "${prefix}${CONSOLE_BIN} extend-contract $suffix" || \
        abort "Command 'extend-contract' failed"
    log ""

    log "Update status for outdated contracts"
    eval "${prefix}${CONSOLE_BIN} contracts-outdated $suffix" || \
        abort "Command 'contracts-outdated' failed"
    log ""

    
}

function setup {
    test -x "$CONSOLE_BIN" || \
        abort "Script '${CONSOLE_BIN}' not found"

    test -d "$INSTANCE_PATH" || \
        abort "No i-doit instance found under '${INSTANCE_PATH}'"
}

function log {
    echo -e "$1"
}

function finish {
    log "Done. Have fun :-)"
    exit 0
}

function abort {
    echo -e "$1"  1>&2
    echo "Operation failed. Please check what is wrong and try again." 1>&2
    exit 1
}

##--------------------------------------------------------------------------------------------------

if [[ "${BASH_SOURCE[0]}" = "$0" ]]; then
    setup && execute && finish
fi